/* compile.h
	P.Chongstitvatana

	14 Jan 2004  project som-som2
	25 Dec 2004  som3-j  change memory model
		separate cell[]
	30 Dec 2004  som-in-som
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "icname.h"

/*
#define DEBUG

#define VERBOSE
*/

/* memory map
  M[  system | --> DS   | --> CS | --> SS ]

    <-N_SYS-> <- N_DS -> <- N_CS-><-N_SS->
          MAXSYS     MAXDS      MAXCS  MAXMEM

  cell[MAXCELL]

*/

#define N_CS			100000
#define N_DS	        300000
#define N_SYS			1000	// interface C-som
#define N_SS			100000

#define MAXMEM			(N_SYS+N_DS+N_CS+N_SS)
#define MAXDS           (N_SYS+N_DS)
#define MAXSYS			N_SYS
#define MAXCS			(N_SYS+N_DS+N_CS)

#define EOF_CHAR		255
#define OBJ_SOMv2		5678920  // magic version 2.0

extern  int *CS;			/* code segment */
extern  int M[];			/* data segment */
extern  int DP;				/* free data pointer */

/* function prototypes */

void eval(int a);				/* interp.c */
int xalloc(int a);
void error(char *mess, int ip);

